#ifndef _BTETRIS_H_
#define _BTETRIS_H_

#define VERSION "1.0"

#define COPYRIGHT  "This program is under the Gnu General Public license; "\
"you may freely distribute it provided you include the source.  Please "\
"refer to the file LICENSE that came with the program for details."
 
#define USAGE \
"Left Arrow\t\tMove left\n" \
"Right Arrow\tMove right\n" \
"Up Arrow\t\tRotate left\n" \
"Down Arrow\tRotate right\n" \
"Space\t\tDrop\n" \
"p\t\t\tPause\n" \
"n\t\t\tNew game\n" \
"q\t\t\tQuit" 

#define START_PULSE_RATE 500000
#define PULSE_INCREMENT 50
 
enum {
	BT_PAUSE	= 'tpse',
	BT_UNPAUSE	= 'tunp',
	BT_TPAUSE	= 'ttps',
	BT_NEW		= 'tnew',
	BT_END		= 'tend',
	BT_SPEEDUP	= 'tspd'
};



class TetrisWindowView : public BView 
{
public:
	TetrisWindowView(BRect frame, char *name);	
	void AllAttached(void);
	BMenuBar *menubar;
	void Pause(void);
    void Continue(void);
    void Restart(void);
    void End(void);
	void DrawNext(void);
	void DrawScore(void);
private:
    TetrisView *view;
    TetrisStatusView *statusView;
    BMenuItem *PauseItem;
    
};



class TetrisWindow : public BWindow
{
public:
	TetrisWindow(BRect frame);
	virtual bool QuitRequested();
	void Pause(void);
	void Continue(void);
	void Restart(void);
	void End(void);
	void Speedup(void);

private:
	TetrisWindowView *sview;
	long long PulseRate;
};

class AboutWindow : public BWindow
{
public:
	AboutWindow(BRect frame);
	virtual bool QuitRequested();
};

class TetrisApplication : public BApplication {
public:
	int abouting;
	TetrisApplication();
	virtual void AboutRequested(void);
	virtual void MessageReceived(BMessage *msg);
private:
	int paused;
	TetrisWindow *win;
 
};

#endif


