// More or less Generic Tetris class.
// Should not be Be Specific, but I haven't tested it.
// The table of shapes.

#include "Tetris.h"

// The table of shapes
struct  {
	int shape[SWIDTH][SHEIGHT]; // n by n array containing layout of shape
	int rotate; // Point to rotate the shape around.
	int x,y;  // actual size of shape
} shape_table[SHAPE_COUNT+1]=
{{  // The first should always be a dummy shape
{{0,0,0,0},
 {0,0,0,0},
 {0,0,0,0},
 {0,0,0,0}},
 1,0,0
},{
{{0,0,0,0},
 {1,1,1,1},
 {0,0,0,0},
 {0,0,0,0}},
 1,4,3
},{
{{0,2,0,0},
 {2,2,2,0},
 {0,0,0,0},
 {0,0,0,0}},
 3,3,2
},{
{{3,3,0,0},
 {3,3,0,0},
 {0,0,0,0},
 {0,0,0,0}},
 2,2,2
},{
{{4,4,0,0},
 {0,4,4,0},
 {0,0,0,0},
 {0,0,0,0}},
 3,3,2
},{
{{0,5,5,0},
 {5,5,0,0},
 {0,0,0,0},
 {0,0,0,0}},
 3,3,2
},{
{{6,6,6,0},
 {0,0,6,0},
 {0,0,0,0},
 {0,0,0,0}},
 3,3,2
},{
{{0,0,7,0},
 {7,7,7,0},
 {0,0,0,0},
 {0,0,0,0}},
 3,3,2
}};



Tetris::Tetris()
{	
	Restart();
}

void Tetris::Restart()
{
	Reset();
	picknexttype();
	picknexttype();
	newshape();
	shapeadd();
}


void Tetris::Reset(void)
{
	int i,j;
	for(j=0;j<HEIGHT;j++)
	{
		for(i=0;i<WIDTH;i++)
			map[i][j]=0;
		cleared[j]=false;
	}
	wellfull=false;
	score=0;
	x=0;
	y=0;
	type=0;
	for(i=0;i<SWIDTH;i++)
		for(j=0;j<SHEIGHT;j++)
			shape[i][j]=0;		
}

void Tetris::GetShape(int type,char buffer[SWIDTH][SHEIGHT],int *x,int *y) {
	int i,j;
	for(i=0;i<SHEIGHT;i++) {
		for(j=0;j<SWIDTH;j++) {
				buffer[j][i]=shape_table[type].shape[j][i];
		}
	}
	*x=shape_table[type].x;
	*y=shape_table[type].y;
}


bool Tetris::newshape(void)
{
	Rect dummy;
	int i,j;
	int rotate;
	bool full=false;
	// mark old shape as being not active
	for(i=0;i<SWIDTH;i++)
		for(j=0;j<SHEIGHT;j++) {
			map[i+x][j+y] &= 0xff;	
	}
	type=nexttype;
	x=(random()%(WIDTH-4))+1;
	y=0;
	for(i=0;i<SWIDTH;i++)
		for(j=0;j<SHEIGHT;j++)
		{
			shape[i][j]=shape_table[type].shape[i][j];
			if((map[i+x][j+y])&&(shape[i][j])) {
				full=true;
			}
		}
	//rotate=random()%4;
	//for(i=0;i<rotate;i++)
	//	Rotate(Left,&dummy);	
	
	
	picknexttype();
	return(!full);
}

void Tetris::Rotate(Direction Dir,Rect *exposed)
{
	int i,j;
	int newshape[SWIDTH][SHEIGHT];
	for(i=0;i<shape_table[type].rotate;i++)
	{
		for(j=0;j<shape_table[type].rotate;j++)
		{
			if(Dir==Left)
			{ 
				newshape[j][i]=shape[shape_table[type].rotate-i-1][j];
			
			}
			else
			{
			 	newshape[j][i]=shape[i][shape_table[type].rotate-j-1];
			}
		}
		for(;j<SWIDTH;j++) {
			newshape[j][i]=shape[i][j];
		}
	}
	for(;i<SHEIGHT;i++) {
		for(j=0;j<SWIDTH;j++) {
			newshape[j][i]=shape[i][j];
		}
	}
	if(occupied(NONE,newshape))
		return;
	
	shapeclear();
	for(i=0;i<SWIDTH;i++)
		for(j=0;j<SHEIGHT;j++)
			shape[i][j]=newshape[i][j];
	
	shapeadd();
	exposed->Set(x,y,(x+SWIDTH),(y+SHEIGHT));
}

void Tetris::shapereset()
{
	clean();
	if(newshape()) {
		shapeadd();
	} else {
		wellfull=true;
	}
}

void Tetris::clean(void)
{
	int filled[HEIGHT];
	int i,j,k;
	int offset=0;
	bool full;
	for(j=0;j<HEIGHT;j++)
	{	
		full=true;
		for(i=0;i<WIDTH;i++)
			if(!map[i][j]) {
				full=false;
			}
		if(full) {
			cleared[j]=true;
			score+=5;
		} else {
			cleared[j]=false;
		}
	}
	k=HEIGHT-1;
	for(j=HEIGHT-1;j>=0;j--) {
		if(cleared[j]) {
			offset++;
			k++;
		} else {
			for(i=0;i<WIDTH;i++) {
				map[i][k]=map[i][k-offset];
			}
		}
		k--;
	}
}



bool Tetris::Advance(Rect *exposed)
{
	if(!Move(Down,exposed)) {
		score++;
		shapereset();
		exposed->Set(0,0,WIDTH,HEIGHT);
		return false;
	}
	return true;
}

void Tetris::shapeadd()
{
	int i,j;

	for(i=0;i<SHEIGHT;i++){ 
		for(j=0;j<SWIDTH;j++) {
			if((shape[i][j])&&(x+i>=0)&&(x+i<WIDTH)&&(j+y>=0)&&(j+y<HEIGHT)) {
				map[i+x][j+y]=(type | 0xf00);
			}	
		}
	}

}

void Tetris::shapeclear(void)
{
	int i,j;
	for(i=0;i<SWIDTH;i++)
		for(j=0;j<SHEIGHT;j++)
			if((x+i>=0)&&(x+i<WIDTH)&&(j+y>=0)&&(j+y<HEIGHT)&&(shape[i][j]))
				map[x+i][y+j]=0;	
}


void Tetris::shift(Direction Dir)
{
	shapeclear();
			
	if(Dir==Left)
		x--;
	else if(Dir==Right)
		x++;
	else
		y++;
	shapeadd();	
}

bool Tetris::occupied(Direction Dir,int shape[SWIDTH][SHEIGHT])
{
	int x_off=0;
	int y_off=0;
	int i,j;
	if(Dir==Left) {
		x_off=-1;
	} else if (Dir==Right) {
		x_off=1;
	} else if (Dir==Down) {
		y_off=1;
	}
	// Check for collision.  We do this by setting a high bit in all non
	// active squares, so we don't get confused by what we occupy (this
	// leads to simpler code then the heinous if that I had before)
	for(i=0;i<SWIDTH;i++) {
		for(j=0;j<SHEIGHT;j++) {
		     if((shape[i][j]) &&
		       (((x+i+x_off>(WIDTH-1)) || (x+i+x_off<0) || 
		        ((y+j+y_off)>(HEIGHT-1))) ||
		        ((map[x+i+x_off][y+j+y_off]!=0) &&
		         !((map[x+i+x_off][y+j+y_off] & 0xf00)))))
		      
		     {
			   return(true);
			 }
		}	
	}
	return(false);
}



bool Tetris::Move(Direction Dir,Rect *exposed)
{
	if(!occupied(Dir,shape)) {
 		shift(Dir);
		*exposed=getexpose();
		return true;	
	} else {
		return false;
	}
}

Rect Tetris::getexpose(void)
{
	Rect rect((x-1),(y-1),(x+SWIDTH+1),(y+SHEIGHT+1));
	return(rect);
}


