#ifndef _TETRIS_H_
#define _TETRIS_H_

// First, the constants of this tetris.
//  

// Width and Height of the well
#define WIDTH 10
#define HEIGHT 25
// Width and Height of the pieces
#define SHEIGHT 4
#define SWIDTH 4

// A Generic Rect class, to be portable

class Rect 
{
public:
	Rect() {};
	Rect(int x1,int y1,int x2,int y2) {xmin=x1;xmax=x2;ymin=y1;ymax=y2;};
	int xmin;
	int xmax;
	int ymin;
	int ymax;
	void Set(int x1,int y1,int x2,int y2) {xmin=x1;xmax=x2;ymin=y1;ymax=y2;};
};

// Number of Shapes.  If you update the shape_table, make sure you update
// This
#define SHAPE_COUNT 7

// Directions a pece can be moved or fall
enum Direction {Left,Right,Down,NONE};

// The tetris class itself
class Tetris
{
public:
// Most functions take a Rect *exposed.  This is a rect specifying the
// area that has been changed so the calling class can redraw efficiently.
	Tetris();  // constructor.
	void Restart(void);  // Start again
	bool Advance(Rect *exposed);  // Advances the current piece by one
	bool Move(Direction Dir,Rect *exposed); // moves piece direction
	int OccupiedBy(int x,int y) {return (map[x][y] &0xff);}; // is x,y occupied?
	int Active(int x,int y) {return (map[x][y] & 0xf00);}; // is x,y an active sqr?
	bool *GetCleared(void) {return cleared;}; // Did the last move clear
	                                          // a row?
	void Rotate(Direction Dir,Rect *exposed); // rotate the piece in dir
	int GetScore(void) {return score;}; // Get the current score
	bool WellFull(void) {return wellfull;}; // Is the well full? (ie game over)
	void Reset(void);  // empty the well, reset everything, etc etc.
	int GetNext(void) {return nexttype;}; // what is the next piect
	void GetShape(int type,char buffer[SWIDTH][SHEIGHT],int *x,int *y);
private:
	bool cleared[HEIGHT];
	bool wellfull;
	int score;
	int map[WIDTH][HEIGHT];
	int shape[SWIDTH][SHEIGHT];
	int x;
	int y;
	int type;
	int nexttype;
	void picknexttype(void) {nexttype=(random()%SHAPE_COUNT)+1;};
	bool newshape(void);
	Rect getexpose(void);
	void shapereset(void);
	void shift(Direction Dir);	
	bool occupied(Direction Dir,int shape[SWIDTH][SHEIGHT]);
	void shapeadd(void);	
	void clean(void);
	void shapeclear(void);	
};


#endif