#ifndef _TETRIS_VIEW_H
#define _TETRIS_VIEW_H

// The following converts my generic Rect class to a BRect.
#define RtoBR(x) Set((x).xmin*EX,(x).ymin*EY,(x).xmax*EX,(x).ymax*EY)

// Number of Pixels for X and Y size
#define EX 20
#define EY 20


// Layout for Status Box.

// Height of the Status Box
#define STATUSHEIGHT 40
// Size of the next peiece square
#define NEXTSIZE 24

// Next two defines determine Y pos of status box
#define NEXTY1 ((STATUSHEIGHT/2)-(NEXTSIZE/2))
#define NEXTY2 ((STATUSHEIGHT/2)+(NEXTSIZE/2))

class TetrisStatusView : public BView
{
public:
	TetrisStatusView(BRect frame, char *name);
virtual void  AttachedToWindow(void);
virtual void Draw(BRect rect);
void  DrawNext(void);
 void  DrawScore();

private:
	BStringView *score;
	int NEXTX1, NEXTX2;  // These are variable depending on string.
	int yfontpos;
	int xscorepos;
	int scorewidth;
};

class TetrisView : public BView 
{
	public:
	 TetrisView(BRect rect,char *name);
virtual void AttachedToWindow();
virtual void Draw(BRect updateRect);
virtual void Pulse(void);
virtual void KeyDown(const char *bytes,int32 numBytes);
	void Clear(int filled[HEIGHT]);
	void DrawCleared(bool *cleared);
	void Reset(void);
	void Pause(void);
	void Continue(void);
private:
	int paused;

};



#endif